UNIT mTMuehle;

interface

uses      mSuM;
// Uses-Klausel ggf. anpassen

type
   TMuehle = CLASS

     // Attribute
     protected
         hatStift : BuntStift;
         zFarbe : GanzeZahl;
         kenntMaus : Maus;
         zGeschwindigkeit : Zahl;
         zGroesse : Zahl;
         zRichtung : Zahl;
         zXPos : Zahl;
         zYPos : Zahl;

     // Methoden
     public
        constructor init(pX,pY,pGroesse,pGeschwindigkeit:Zahl;pFarbe:ganzeZahl);
        procedure drehe;
        procedure langsamer;
        procedure loesche;
        procedure schneller;
        procedure setzeGeschwindigkeit(pGeschwindigkeit:Zahl);
        procedure zeichne;
        function Geschwindigkeit : Zahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TMuehle: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TMuehle.init(pX,pY,pGroesse,pGeschwindigkeit:Zahl;pFarbe:ganzeZahl);
begin
  zXpos := pX;
  zYPos := py;
  zGroesse := pGroesse;
  zGeschwindigkeit := pGeschwindigkeit;
  zRichtung := 0;
  zFarbe := pFarbe;
  hatStift := BuntStift.init;
  hatStift.wechsle;
  zeichne
end;

//-------- drehe (public) ----------------------------------------------
procedure TMuehle.drehe;
begin
   loesche;
   zRichtung := zRichtung + zGeschwindigkeit;
   zeichne
end;

//-------- langsamer (public) ------------------------------------------
procedure TMuehle.langsamer;
begin
  if zGeschwindigkeit > 0.1 then zGeschwindigkeit := zGeschwindigkeit - 0.1
end;

//-------- loesche (public) --------------------------------------------
procedure TMuehle.loesche;
begin
  zeichne
end;

//-------- schneller (public) ------------------------------------------
procedure TMuehle.schneller;
begin
  zGeschwindigkeit := zGeschwindigkeit + 0.2
end;

//-------- setzeGeschwindigkeit (public) -------------------------------
procedure TMuehle.setzeGeschwindigkeit(pGeschwindigkeit:Zahl);
begin
   zGeschwindigkeit := pGeschwindigkeit
end;

//-------- zeichne (public) --------------------------------------------
procedure TMuehle.zeichne;
begin
  hatStift.setzeFarbe(zFarbe);
  hatStift.hoch;
  hatStift.bewegeBis(zXpos,zYPos);
  hatStift.setzeLinienBreite(2);
  hatStift.runter;
  hatStift.bewegeBis(zXpos,zYpos-zGroesse);
  hatStift.dreheBis(zRichtung);
  hatStift.setzeLinienBreite(1);
  hatStift.bewegeUm(zGroesse/2);
  hatStift.dreheUm(180);
  hatStift.hoch;
  hatStift.bewegeUm(zGroesse/2);
  hatStift.runter;
  hatStift.bewegeUm(zGroesse/2);
  hatStift.hoch
end;

//-------- Geschwindigkeit (public) ------------------------------------
function TMuehle.Geschwindigkeit : Zahl;
begin
  result := zGeschwindigkeit
end;

//-------- gibFrei (public) --------------------------------------------
destructor TMuehle.gibFrei;
begin
  zeichne
end;

end.
