UNIT mTAnwendung;

interface

uses  mSuM, mTKnopf, mTKreisknopf, mTRechteckKnopf;
// Uses-Klausel ggf. anpassen

type
   TAnwendung = CLASS

     // Attribute
     private
        derBildschirm : Bildschirm;
        dieMaus : Maus;
        hatStift : Stift;
        dieTastatur : Tastatur;
        Knopf1 :TKreisknopf;
        Knopf2 :TRechteckKnopf;

     // Methoden
     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  hatStift      := Stift.init;
  dieTastatur   := Tastatur.init;
  Knopf1        := TKreisknopf.init(50,100,20,'test',dieMaus);
  Knopf2        := TRechteckknopf.init(150,300,80,'test2',dieMaus);
end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
begin
   repeat
      if dieMaus.istGedrueckt then
         if Knopf1.angeklickt then begin
            hatStift.bewegeBis(5,400);
            hatStift.schreibeText('Knopf 1 gedrckt                       ');
         end
         else if Knopf2.angeklickt then begin
            hatStift.bewegeBis(5,400);
            hatStift.schreibeText('Knopf 2 gedrckt                       ');
         end
         else begin
            hatStift.bewegeBis(5,400);
            hatStift.schreibeText('es wurde kein Knopf gedrckt');
         end

   until dieMaus.doppelklick
end;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  dieTastatur.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;

end.
