UNIT mTFluegelKapp;

// Damit die Flgel der Windmhle bei der Kappenwindmhle
// vor einer farbigen Hintergrundflche ohne die Bildung von Farbdifferenzen
// erscheinen knnen, muss der Wechselmodus abgeschaltet werden.
// Er wird durch abwechselndes Umschalten zwischen Lsch- und Normalmodus
// ersetzt. Der jeweils letzte Zustand wird in "zloeschen" lokal gespeichert.
// Durch das zustzliche Attribut "zBreite" wird es mglich, zwecks differenzierterer
// Darstellung der Windmhlenflgel zwischen unterschiedlichen Strichbreiten
// umzuschalten. Dies macht einen neuen Konstruktor notwendig, der wegen vernderter
// Parameterliste den von "TFluegel" berldt.

interface

uses  mSuM, mTFluegel;

type
   TFluegelKapp = CLASS(TFluegel)

     // Attribute
     private
        zloeschen : Boolean;
        zBreite : Integer;

     // Methoden
     public
        constructor init(px,py,pGroesse,pFluegel,pBreite:Integer;pBuntstift:Buntstift); overload;
        procedure zeichne; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TFluegelKapp: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TFluegelKapp.init(px,py,pGroesse,pFluegel,pBreite:Integer;pBuntstift:Buntstift);
begin
  inherited init (px,py,pGroesse,pFluegel,pBuntstift);
  zloeschen := False;
  zBreite := pBreite;
end;

//-------- zeichne (public) --------------------------------------------
procedure TFluegelKapp.zeichne;
Var   i : Integer;
begin
  if zloeschen
  then kenntBuntstift.radiere
  else kenntBuntstift.normal;
  zloeschen := NOT zloeschen;

     for i:= 1 to zFluegel*2 do
        begin
          kenntBuntstift.bewegeBis(zx,zy);
          kenntBuntstift.runter;
          kenntBuntstift.bewegeUm(zGroesse*10);
          kenntBuntStift.bewegeUm(-zGroesse);
          kenntBuntStift.setzeLinienBreite(zBreite div 2);
          kenntBuntstift.dreheUm (90);
          kenntBuntStift.bewegeUm(2*zGroesse);
          kenntBuntstift.dreheUm (90);
          kenntBuntStift.bewegeUm(8*zGroesse);
          kenntBuntstift.dreheUm (90);
          kenntBuntStift.bewegeUm(2*zGroesse);
          kenntBuntstift.dreheUm (90);
          kenntBuntStift.setzeLinienBreite(zBreite);
          kenntBuntstift.hoch;
          kenntBuntstift.dreheUm(360/(2*zFluegel));
         end ;

     kenntBuntstift.dreheUm(360/(2*zFluegel));
 
end;

end.
