UNIT mTMuehle;

interface

uses mSum, mTFluegel,mTFluegelKapp, mTCorpus, mTCorpusMast, mTCorpusDrei, mTCorpusKapp;

type
   TMuehle = CLASS

     private
        hatFluegelStift : Buntstift;
        zWinkel         : Real;
        zStartinkrement : Real;

        hatCorpus       : TCorpus;
        hatFluegel      : TFluegel;


     public
        constructor init(px,py,pFarbe,Pgroesse,pCorpus,pFluegel:Integer;pWinkel:Real);
        procedure drehe;
        procedure langsamer;
        procedure schneller;
        procedure ruhe;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TMuehle: Methodendefinition
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TMuehle.init(px,py,pFarbe,Pgroesse,pCorpus,pFluegel:Integer;pWinkel:Real);
var         zBreite : Integer;
begin
  // Attribute setzen
  zWinkel:=pWinkel;
  zStartinkrement:=zWinkel;   //individuelle Grundgeschwindigkeit retten

  // Flgel und zugehrigen Stift initialisieren
  case pGroesse of
    1..2  : zBreite:=1;
    3..5  : zBreite:=2;
    6..10 : zBreite:=4;
    else    zBreite:=8;
  end;
  hatFluegelStift:=Buntstift.init;
  hatFluegelStift.setzeFarbe(pFarbe);
  hatFluegelStift.setzeLinienBreite(zBreite);
  hatFluegelStift.wechsle;
  if pCorpus > 1
  then hatFluegel := TFluegelKapp.init (px,py,pGroesse,2,zBreite,hatFluegelStift)
  else hatFluegel := TFluegel.init     (px,py,pGroesse,pFluegel,hatFluegelStift);


  // Corpus initialisieren
  Case pCorpus of
    1  : hatCorpus := TCorpusDrei.init (px,py,pFarbe,pGroesse);
    2  : hatCorpus := TCorpusKapp.init (px,py,pFarbe,pGroesse);
    else hatCorpus := TCorpusMast.init (px,py,pFarbe,pGroesse);
  end;

  // Mhle zeichnen
  hatCorpus.zeichne;
  hatFluegel.zeichne;

  end;

//-------- drehe (public) ----------------------------------------------
procedure TMuehle.drehe;
begin
  hatFluegel.zeichne;
  hatCorpus.zeichne;
  hatFluegelStift.dreheUm(zWinkel);
  hatFluegel.zeichne;

end;

//-------- langsamer (public) ------------------------------------------
procedure TMuehle.langsamer;
begin
 zWinkel:=zWinkel-0.03*zStartinkrement;
end;

//-------- schneller (public) ------------------------------------------
procedure TMuehle.schneller;
begin
 zWinkel:=zWinkel+0.03*zStartinkrement;
end;

//-------- Ruhe (public) ------------------------------------------
procedure TMuehle.ruhe;
begin
 zWinkel:=0 ;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TMuehle.gibFrei;
begin
  hatFluegel.gibFrei;
  hatFluegelStift.gibFrei;
end;

end.
