UNIT mTMuehlen;

interface

uses    mSum, mTKnopf;
// Uses-Klausel ggf. anpassen

type
   TMuehlen = CLASS

     // Attribute
     private
        hatStift : Buntstift;
        zDx, zDy, zb, zh : integer;
        zAnzFluegel : integer;
        zSpeed : real;

     // Methoden
     public
        constructor init(px,py,pb,ph,pf:integer);
        procedure dreheFluegel;
        procedure langsamer;
        procedure schneller;
        procedure zeichneFluegel(panzahl:integer);
        procedure zeichneMast;

   end;

implementation

//+---------------------------------------------------------------------
//|         TMuehlen: Methodendefinition
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TMuehlen.init(px,py,pb,ph,pf:integer);
begin
  zSpeed := 5;
  zAnzFluegel := pf;
  zDx := px; zDy := py; zb := pb; zh := ph;
  hatStift := Buntstift.init;
  hatStift.setzeLinienBreite(2);
  hatStift.bewegeBis(zDx,zDy);
  hatStift.runter;
  zeichneMast;
  hatStift.wechsle; 
  hatStift.dreheBis(0);
  zeichneFluegel(pf);
    //Hier Code einfgen.
end;

//-------- dreheFluegel (public) ---------------------------------------
procedure TMuehlen.dreheFluegel;
begin

  zeichneFluegel(zAnzFluegel);
  hatStift.dreheUm(zSpeed);


  zeichneFluegel(zAnzFluegel);
  //Hier Code einfgen.
end;

//-------- langsamer (public) ------------------------------------------
procedure TMuehlen.langsamer;
begin
  zSpeed := zSpeed * 0.9;
  //Hier Code einfgen.
end;

//-------- schneller (public) ------------------------------------------
procedure TMuehlen.schneller;
begin
  zSpeed := zSpeed* 1.1;
  //Hier Code einfgen.
end;

//-------- zeichneFluegel (public) -------------------------------------
procedure TMuehlen.zeichneFluegel(panzahl:integer);
var
  i : integer;
begin

  FOR i := 1 to panzahl do begin
    hatStift.bewegeUm(50);    hatStift.hoch;
    hatStift.bewegeUm(-50);   hatStift.runter; {wichtig fr wechsle Modus}
    hatStift.dreheUm(360/panzahl);
  end;
  //Hier Code einfgen.
end;

//-------- zeichneMast (public) ----------------------------------------
procedure TMuehlen.zeichneMast;
begin
  hatStift.normal;
  hatStift.bewegeBis(zDx-(zb div 2),zDy+zh);
  hatStift.BewegeBis(zDx+(zb div 2),zDy+zh);
  hatStift.BewegeBis(zDx,zDy);
  //Hier Code einfgen.
end;

end.
