UNIT mTMuehle;

interface

uses
mSum;

type
   TMuehle = CLASS

     // Attribute
     private
        zWindstaerke : ganzeZahl;
        hatStift : Buntstift;
     public
        ZFarbe : GanzeZahl;
        zFussTyp : GanzeZahl;
        ZAnzahl : GanzeZahl;
        zHPos : zahl;
        zLaenge : Zahl;
        zVPos : Zahl;

     // Methoden
     private
        procedure zeichneFuss;
        procedure zeichne;
     public
        constructor init(pHPos, pVPos, pLaenge:Zahl;pAnzahl, pFarbe,pFusstyp:ganzeZahl);
        procedure drehe(zGeschwindigkeit:Zahl);
        procedure langsamer;
        procedure schneller;
        destructor gibFrei;
   end;

implementation

//+---------------------------------------------------------------------
//|         TMuehle: Methodendefinition
//+---------------------------------------------------------------------

//-------- drehe (private) ---------------------------------------------
procedure TMuehle.drehe(zGeschwindigkeit:Zahl);
begin
  self.zeichne;
  hatStift.dreheUm(zWindstaerke*5 DIV zAnzahl);
  self.zeichne;
end;


//-------- init (public) -----------------------------------------------
constructor TMuehle.init(pHPos, pVPos, pLaenge:Zahl;pAnzahl,pFarbe,
                          pFusstyp:ganzeZahl);
begin
 hatStift := Buntstift.init;
 hatStift.setzeLinienBreite(2);
 hatStift.setzeFarbe(pFarbe);
 hatStift.bewegeBis(pHPos, pVPos);
 zHPos := pHPos; zVPos := pVPos; zLaenge := pLaenge; zAnzahl := pAnzahl;
 zFarbe := pFarbe; zFusstyp := pFusstyp;
 zWindstaerke :=3;
 self.ZeichneFuss;
 self.Zeichne;
 self.drehe(zWindstaerke);
end;

procedure TMuehle.zeichneFuss;
var merkex, merkey : Zahl;
begin
  hatStift.dreheUm(-90+5*zFusstyp);
  hatStift.runter;
  hatStift.BewegeUm(150);
  merkex := hatStift.hPosition; merkey := hatStift.vPosition;
  hatStift.bewegeBis(zHPos, zVPos);
  hatStift.dreheUm(-10*zFusstyp);
  hatStift.BewegeUm(150);
  hatStift.bewegeBis(merkex, merkey);
  hatStift.dreheBis(0);
  hatStift.bewegeBis(zHPos, zVPos);
end;

//-------- zeichne (private) -------------------------------------------
procedure TMuehle.zeichne;
var I : ganzeZahl;
begin
 hatStift.wechsle;
for I := 1 to zAnzahl do
  begin
    hatStift.runter;
    hatStift.bewegeUm(zLaenge);
    hatStift.hoch;
    hatStift.bewegeBis(zHPos,zVPos);
    hatStift.dreheUm(360/zAnzahl);
  end;
  hatStift.hoch;
  hatStift.normal;
end;

//-------- langsamer (public) ------------------------------------------
procedure TMuehle.langsamer;
begin
  zWindstaerke := zWindstaerke - 1;
end;

//-------- schneller (public) ------------------------------------------
procedure TMuehle.schneller;
begin
  zWindstaerke := zWindstaerke + 1;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TMuehle.gibFrei;
begin
  hatStift.gibFrei;
end;

end.
