UNIT mTAnwendung;

interface

uses mSuM, mUhr, mTmuehle, mTKreisknopf, mTRechteckknopf;

type
   TAnwendung = CLASS

     // Attribute
     private
        derBildschirm : Bildschirm;
        dieMaus : Maus;
        KLangsamer : TKreisknopf;
        KSchneller : TKreisknopf;
        KEnde : TRechteckknopf;
        dieUhr : Uhr;
        muehle1 : Tmuehle;

  
     // Methoden
     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dieUhr        := Uhr.init;
  KSchneller    := TKreisknopf.init(50, 510, 20, dieMaus, '+');
  KLangsamer    := TKreisknopf.init(100, 510, 20, dieMaus,'-');
  KEnde         := TRechteckknopf.init(150, 490, 20, dieMaus, 'Ende');
  muehle1       := Tmuehle.init (200, 250, 100,2, rot);
end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
begin
   repeat muehle1.BewegeRotor;
          if KSchneller.getroffen
             then begin
                  muehle1.bewegeRotorSchneller;
                  end
             else if KLangsamer.getroffen
                     then begin
                          muehle1.bewegeRotorLangsamer;
                          end;
         muehle1.BewegeRotor;
         dieUhr.warte(10);
   until KEnde.getroffen
end;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  KLangsamer.gibFrei;
  KSchneller.gibFrei;
  KEnde.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei;
  muehle1.gibFrei
end;

end.
