UNIT mTmuehle;

interface

uses  mSum;

type
   Tmuehle = CLASS

     // Attribute
     protected
         hatStift : Buntstift;
         zFarbe : INTEGER;
         zGeschwindigkeit : Zahl;
         zgroesse : Zahl;
         zx : Zahl;
         zy : Zahl;

     // Methoden
     protected 
        procedure zeichne;
        procedure zeichneRotor;

     public
        procedure bewegeRotor;
        procedure bewegeRotorLangsamer;
        procedure bewegeRotorSchneller;
        constructor init(px,py,pgroesse,pGeschwindigkeit:Zahl;pFarbe:INTEGER);
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         Tmuehle: Methodendefinition 
//+---------------------------------------------------------------------


//-------- init (public) -----------------------------------------------
constructor Tmuehle.init(px,py,pgroesse,pGeschwindigkeit:Zahl;pFarbe:INTEGER);
begin
  hatStift := BuntStift.init;
  zFarbe := pFarbe;
  zGeschwindigkeit := pGeschwindigkeit;
  zgroesse := pGroesse;
  zx := px;
  zy := py;
  self.zeichne;
  hatStift.wechsle;
  self.zeichneRotor;
end;

//-------- zeichneRotor (protected) ------------------------------------
procedure Tmuehle.zeichneRotor;
begin 
  hatStift.setzeFarbe(zFarbe);
  hatStift.setzeLinienBreite(5);
  hatStift.hoch;
  hatStift.bewegeBis(zx,zy);
  hatStift.runter;
  hatStift.bewegeUm(zGroesse);
  hatStift.DreheUm(180);
  hatStift.hoch;
  hatStift.bewegeBis(zx,zy);
  hatStift.runter;
  hatStift.bewegeUm(zGroesse);
  hatStift.DreheUm(180);
  hatStift.hoch;
end;

//-------- bewegeRotor (public) -------------------------------------
procedure Tmuehle.bewegeRotor;
begin
  self.zeichneRotor;  //lscht den alten Rotor
  hatStift.dreheUm(zGeschwindigkeit);
  self.zeichneRotor;  //zeichnet den neuen Rotor
end;

//-------- bewegeRotorLangsamer (public) ----------------------------
procedure Tmuehle.bewegeRotorLangsamer;
begin
  zGeschwindigkeit := zGeschwindigkeit * 0.9;
end;

//-------- bewegeRotorSchneller (public) ----------------------------
procedure Tmuehle.bewegeRotorSchneller;
begin
  zGeschwindigkeit := zGeschwindigkeit * 1.1;
end;

//-------- zeichne (protected) -----------------------------------------
procedure Tmuehle.zeichne;
begin
  hatStift.bewegeBis(zx,zy);
  hatStift.runter;
  hatStift.dreheBis(-90);
  hatStift.setzeFarbe(zFarbe);
  hatStift.setzeLinienBreite(20);
  hatStift.bewegeUm(2*zGroesse);
  hatStift.hoch;
end;

//-------- gibFrei (public) --------------------------------------------
destructor Tmuehle.gibFrei;
begin
  hatStift.gibFrei;
end;

end.

