UNIT mTAnwendung;

interface

uses mSuM, mUhr, mTmuehle, mTKreisknopf, mTRechteckknopf, mTZweiarmmuehle,
     mTDreiarmmuehle, mTFluegelmuehle;

type
   TAnwendung = CLASS

     // Attribute
     private
        derBildschirm : Bildschirm;
        dieMaus : Maus;
        KLangsamer : TKreisknopf;
        KSchneller : TKreisknopf;
        KEnde : TRechteckknopf;
        dieUhr : Uhr;
        muehle1 : TZweiarmmuehle;
        muehle2 : TDreiarmmuehle;
        muehle3 : TFluegelmuehle;
  
     // Methoden
     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dieUhr        := Uhr.init;
  KSchneller    := TKreisknopf.init(50, 510, 20, dieMaus, '+');
  KLangsamer    := TKreisknopf.init(100, 510, 20, dieMaus,'-');
  KEnde         := TRechteckknopf.init(150, 490, 20, dieMaus, 'Ende');
  muehle1       := TZweiarmmuehle.init(200, 250, 100,2, rot);
  muehle2       := TDreiarmmuehle.init(400, 150, 100, 1.5, gruen);
  muehle3       := TFluegelmuehle.init(600, 350,100,1,blau);
end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
begin
   repeat if KSchneller.getroffen
             then begin
                  muehle1.bewegeRotorSchneller;
                  muehle2.bewegeRotorSchneller;
                  muehle3.bewegeRotorSchneller;
                  end
             else if KLangsamer.getroffen
                     then begin
                          muehle1.bewegeRotorLangsamer;
                          muehle2.bewegeRotorLangsamer;
                          muehle3.bewegeRotorLangsamer;
                          end;
          muehle1.BewegeRotor;
          muehle2.BewegeRotor;
          muehle3.BewegeRotor;
          dieUhr.warte(10);
   until KEnde.getroffen
end;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  KLangsamer.gibFrei;
  KSchneller.gibFrei;
  KEnde.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei;
  muehle1.gibFrei;
  muehle2.gibFrei;
  muehle3.gibFrei;
end;

end.
