UNIT mTAnwendung;

interface

uses    mSuM, mUhr, mTZweier, mtDreier, mtSechser, mtKreisknopf, mtRechteckknopf;

type
   TAnwendung = CLASS

     // Attribute
     private
        derBildschirm : Bildschirm;
        dieMaus : Maus;
        KLangsamer : TKreisknopf;
        KSchneller : TKreisknopf;
        KEnde : TRechteckknopf;
        dieUhr : Uhr;
        muehle21, muehle22: tZweier;
        muehle31, muehle32 : TDreier;
        muehle61, muehle62 : TSechser;

     // Methoden
     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dieUhr        := Uhr.init;
  KSchneller    := TKreisknopf.init(800, 650, '+', dieMaus);
  KLangsamer    := TKreisknopf.init(850, 650, '-', dieMaus);
  KEnde         := TRechteckknopf.init(900, 630, 'Ende', dieMaus);
  muehle21       := TZweier.init (200, 100, 0.6, 150, gruen);
  muehle22       := TZweier.init (180, 300, 0.5, 300, rot);
  muehle31       := TDreier.init (600, 200, 0.4, 200, blau);
  muehle32       := TDreier.init (700, 500, 0.3, 250, pink);
  muehle61       := TSechser.init (400, 500, 0.25, 250, grau);
  muehle62       := TSechser.init (800, 100, 0.1, 150, schwarz);
end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
begin
   repeat
         if KSchneller.angeklickt
           then
             begin
               Muehle21.schneller;
               Muehle22.schneller;
               Muehle31.schneller;
               Muehle32.schneller;
               Muehle61.schneller;
               Muehle62.schneller
             end;
         if KLangsamer.angeklickt
           then
             begin
               Muehle21.langsamer;
               Muehle22.langsamer;
               Muehle31.langsamer;
               Muehle32.langsamer;
               Muehle61.langsamer;
               Muehle62.langsamer
             end;
         Muehle21.bewege; Muehle22.bewege;
         Muehle31.bewege; Muehle32.bewege;
         Muehle61.bewege; Muehle62.bewege;
         dieUhr.warte(10);
   until KEnde.angeklickt
end;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  KLangsamer.gibFrei;
  KSchneller.gibFrei;
  KEnde.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;

end.
