UNIT mTAnwendung;

interface

uses    mSuM, mUhr, mTAuto;

type
   TAnwendung = CLASS

     // Attribute
     private
        derBildschirm : Bildschirm;
        dieMaus : Maus;
        KLangsamer : TKreisknopf;
        KSchneller : TKreisknopf;
        KEnde : TRechteckknopf;
        dieUhr : Uhr;
        dasAuto : TAuto;

     // Methoden
     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dieUhr        := Uhr.init;
  KSchneller    := TKreisknopf.init(********);
  KLangsamer    := TKreisknopf.init(********);
  KEnde         := TRechteckknopf.init(*****);
  dasAuto       := TAuto.init (10,300);
end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
begin
   repeat
         if KSchneller.angeklickt then begin
            dasAuto.schneller
         end
         else if KLangsamer.angeklickt then begin
            dasAuto.langsamer
         end;
         dasAuto.bewege;
         dieUhr.warte(10);
         if dasAuto.hPosition > derBildschirm.breite + 50 then
            dasAuto.setzeAuf(0,300) 
   until KEnde.angeklickt
end;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  KLangsamer.gibFrei;
  KSchneller.gibFrei;
  KEnde.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;

end.
